---
title: The structured clone algorithm
slug: Web/API/Web_Workers_API/Structured_clone_algorithm
tags:
  - Advanced
  - DOM
  - HTML5
  - JavaScript
  - Reference
---
<p><span class="seoSummary">The <strong>structured clone algorithm</strong> copies complex JavaScript objects. It is used internally to transfer data between <a href="/en-US/docs/Web/API/Worker">Workers</a> via {{domxref("Worker.postMessage()", "postMessage()")}}, storing objects with <a href="/en-US/docs/Glossary/IndexedDB">IndexedDB</a>, or copying objects for <a href="#See_Also">other APIs</a>.</span> It clones by recursing through the input object while maintaining a map of previously visited references, to avoid infinitely traversing cycles.</p>

<h2 id="Things_that_dont_work_with_structured_clone">Things that don't work with structured clone</h2>

<ul>
 <li><a href="/en/JavaScript/Reference/Global_Objects/Function" title="en/JavaScript/Reference/Global Objects/Function"><code>Function</code></a> objects cannot be duplicated by the structured clone algorithm; attempting to throws a <code>DATA_CLONE_ERR</code> exception.</li>
 <li>Cloning DOM nodes likewise throws a <code>DATA_CLONE_ERR</code> exception.</li>
 <li>Certain object properties are not preserved:
  <ul>
   <li>The <code>lastIndex</code> property of <a href="/en/JavaScript/Reference/Global_Objects/RegExp" title="en/JavaScript/Reference/Global Objects/regexp"><code>RegExp</code></a> objects is not preserved.</li>
   <li>Property descriptors, setters, getters, and similar metadata-like features are not duplicated. For example, if an object is marked readonly with a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/getOwnPropertyDescriptor">property descriptor</a>, it will be read/write in the duplicate, since that's the default.</li>
   <li>The prototype chain is not walked or duplicated.</li>
  </ul>
 </li>
</ul>

<div class="notecard note">
<p><strong>Note</strong>: Native <a href="/en/JavaScript/Reference/Global_Objects/Error" title="en/JavaScript/Reference/Global Objects/Error"><code>Error</code></a> types can be cloned in Chrome, and Firefox is <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1556604">working on it</a>.</p>
</div>

<h2 id="Supported_types">Supported types</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Object type</th>
   <th scope="col">Notes</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><a href="/en-US/docs/Web/JavaScript/Data_structures#Primitive_values">All primitive types</a></td>
   <td>However, not symbols.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Boolean">Boolean</a> objects</td>
   <td></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/String">String</a> objects</td>
   <td></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date">Date</a></td>
   <td></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/RegExp">RegExp</a></td>
   <td><code>lastIndex</code> is not preserved.</td>
  </tr>
  <tr>
   <td>{{ domxref("Blob") }}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{ domxref("File") }}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{ domxref("FileList") }}</td>
   <td></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/ArrayBuffer">ArrayBuffer</a></td>
   <td></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/ArrayBufferView">ArrayBufferView</a></td>
   <td>Including other <a href="/en-US/docs/Web/JavaScript/Typed_arrays">typed arrays</a>.</td>
  </tr>
  <tr>
   <td>{{ domxref("ImageBitmap") }}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{ domxref("ImageData") }}</td>
   <td></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array">Array</a></td>
   <td></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object">Object</a></td>
   <td><strong>Only</strong> plain objects (e.g. from object literals)</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Map">Map</a></td>
   <td></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Set">Set</a></td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="http://www.w3.org/TR/html5/infrastructure.html#safe-passing-of-structured-data" title="http://www.w3.org/TR/html5/common-dom-interfaces.html#safe-passing-of-structured-data">HTML Specification: Safe passing of structured data</a></li>
 <li>{{ domxref("window.history") }}</li>
 <li>{{ domxref("window.postMessage()") }}</li>
 <li><a href="/en-US/docs/Web/API/Web_Workers_API">Web Workers</a></li>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API">IndexedDB</a></li>
 <li><a href="/en-US/docs/Components.utils.cloneInto">Components.utils.cloneInto</a></li>
</ul>
